import java.io.*;
import java.util.*;
import java.math.*;

public class Avg_dy {
  public static void main(String[] args) throws Exception {
    BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    int q = Integer.parseInt(reader.readLine());
    int mod = 998244353;
    int[] fact = new int[400300];
    fact[0] = 1;
    for (int i = 1; i < fact.length; i++) {
      fact[i] = (int) ((long) fact[i - 1] * i % mod);
    }
    try (PrintWriter out = new PrintWriter(System.out)) {
      for (int i = 0; i < q; i++) {
        String line = reader.readLine();
        StringTokenizer tok = new StringTokenizer(line);
        int n = Integer.parseInt(tok.nextToken());
        int k = Integer.parseInt(tok.nextToken());
        out.println(calcC(n + k - 1, k - 1, fact, mod));
      }
    }
  }

  static long inv(long a, long mod) {
    return BigInteger.valueOf(a).modInverse(BigInteger.valueOf(mod)).longValue();
  }

  static int calcC(int n, int k, int[] fact, int mod) {
    long res = fact[n];
    res *= inv(fact[k], mod);
    res %= mod;
    res *= inv(fact[n - k], mod);
    res %= mod;
    return (int) res;
  }
}
