#include <bits/stdc++.h>
using namespace std;

int const maxn = 1300300;
int const mod = 998244353;

int prod(int a, int b) {
  return (long long) a * b % mod;
}

void add(int &a, int b) {
  if ((a += b) >= mod) {
    a -= mod;
  }
}

int inv[maxn];

void precalc() {
  inv[1] = 1;
  for (int i = 2; i < maxn; ++i) {
    inv[i] = prod(inv[mod % i], mod - mod / i);
    assert(prod(inv[i], i) == 1);
  }
}

void solve() {
  int n, k;
  scanf("%d%d", &n, &k);
  int index = 0;
  int value = 1;
  int sum = 1;
  while (index != n) {
    ++index;
    value = prod(k, prod(sum, inv[index]));
    add(sum, value);
  }
  cout << value << '\n';
}

int main() {
  precalc();
  int tests = 1;
  scanf("%d", &tests);
  for (int i = 0; i < tests; ++i) {
    solve();
  }
}
