#include <bits/stdc++.h>

const int MAXN = 1e4;

template <typename T>
T sqr(T x) {
    return x * x;
}

int main()
{
    int n;
    scanf("%d", &n);
    std::vector<std::multiset<int>> people(MAXN + 1);
    for (int i = 0; i < n; i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        people[x].insert(y);
    }
    int m;
    scanf("%d", &m);
    for (int i = 0; i < m; i++) {
        int x, y, r;
        scanf("%d%d%d", &x, &y, &r);
        for (int sx = std::max(0, x - r); sx <= std::min(MAXN, x + r); sx++) {
            int miny = MAXN + 1;
            int maxy = -1;
            for (int sy = std::max(0, y - r); sy <= std::min(MAXN, y + r); sy++) {
                if (sqr(sx - x) + sqr(sy - y) <= sqr(r)) {
                    miny = std::min(miny, sy);
                    maxy = std::max(maxy, sy);
                }
            }

            auto lb = people[sx].lower_bound(miny);
            auto ub = people[sx].upper_bound(maxy);
            people[sx].erase(lb, ub);
        }
    }

    int answer = 0;
    for (int i = 0; i <= MAXN; i++) {
        answer += people[i].size();
    }

    printf("%d\n", answer);
    return 0;
}
