#include <bits/stdc++.h>
#define link _link
using namespace std;

int const N = 1000100;
int const A = 26;

int go[N][A], len[N], link[N], sz = 0;
int lpos[N], rpos[N];

int get_node(int len, int link) {
  fill(go[sz], go[sz] + A, -1);
  ::len[sz] = len;
  ::link[sz] = link;
  return sz++;
}

int get_copy(int len, int v) {
  copy(go[v], go[v] + A, go[sz]);
  ::len[sz] = len;
  link[sz] = link[v];
  return sz++;
}

int append(int v, int x, int i) {
  int now = get_node(len[v] + 1, 0);
  lpos[now] = rpos[now] = i;
  while (v >= 0 && go[v][x] < 0) {
    go[v][x] = now;
    v = link[v];
  }
  if (v >= 0) {
    int q = go[v][x];
    if (len[v] + 1 == len[q]) {
      link[now] = q;
    } else {
      int y = get_copy(len[v] + 1, q);
      lpos[y] = lpos[q];
      rpos[y] = rpos[q];
      while (v >= 0 && go[v][x] == q) {
        go[v][x] = y;
        v = link[v];
      }
      link[q] = y;
      link[now] = y;
    }
  }
  return now;
}

char s[N];
int start[N], order[N];

void solve() {
  scanf("%s", s);
  int n = strlen(s);
  int root = get_node(0, -1);
  int v = root;
  for (int i = 0; i < n; ++i) {
    int x = s[i] - 'a';
    v = append(v, x, i);
  }
  for (int i = 0; i < sz; ++i) {
    start[len[i] + 1] += 1;
  }
  for (int i = 1; i <= n; ++i) {
    start[i] += start[i - 1];
  }
  for (int i = 0; i < sz; ++i) {
    order[start[len[i]]++] = i;
  }
  for (int i = sz - 1; i >= 0; --i) {
    int v = order[i];
    int to = link[v];
    if (to >= 0) {
      lpos[to] = min(lpos[to], lpos[v]);
      rpos[to] = max(rpos[to], rpos[v]);
    }
  }
  long long ans = n;
  for (int i = 0; i < sz; ++i) {
    if (len[i] > 0 && lpos[i] != rpos[i]) {
      long long cur = (long long) len[i] * len[i] + (len[i] + rpos[i] - lpos[i]);
      ans = max(ans, cur);
    }
  }
  cout << ans << '\n';
}

int main() {
  int tests = 1;
  //scanf("%d", &tests);
  for (int i = 0; i < tests; ++i) {
    solve();
  }
}
