#include <bits/stdc++.h>
#define link _link
using namespace std;

int const N = 500500;
int const A = 276;
int const LOG = 20;

int n;
char s[N];
int sa[N];
int col[LOG][N];
int T;

void build_sa() {
  static int start[N], sa1[N];
  for (int i = 0; i < n; ++i) {
    ++start[1 + s[i]];
  }
  for (int i = 1; i < A; ++i) {
    start[i] += start[i - 1];
  }
  for (int i = 0; i < n; ++i) {
    sa[start[(int)s[i]]++] = i;
    col[0][i] = s[i];
  }
  for (int i = 0; i < n; ++i) {
    --start[(int)s[i]];
  }
  int t = 0;
  for (int h = 1; 1 << h < n; ++h) {
    for (int i = 0; i < n; ++i) {
      int x = (sa[i] + n - h) % n;
      sa1[start[col[t][x]]++] = x;
    }
    int lc = 0;
    start[lc] = 0;
    col[t + 1][sa1[0]] = lc;
    for (int i = 0; i < n - 1; ++i) {
      int j = i + 1;
      if (col[t][sa1[i]] != col[t][sa1[j]] || col[t][(sa1[i] + h) % n] != col[t][(sa1[j] + h) % n]) {
        start[++lc] = j;
      }
      col[t + 1][sa1[j]] = lc;
    }
    copy(sa1, sa1 + n, sa);
    ++t;
  }
  T = t;
}

int where[N];
int blog[N];
int lcp[LOG][N];
int mipos[LOG][N], mapos[LOG][N];

void build_lcp() {
  for (int i = 0; i < n; ++i) {
    where[sa[i]] = i;
  }
  for (int i = 0; i < n - 1; ++i) {
    int x = sa[i];
    int y = sa[i + 1];
    int ans = 0;
    for (int g = T; g >= 0; --g) {
      if (col[g][x] == col[g][y]) {
        ans += 1 << g;
        (x += 1 << g) %= n;
        (y += 1 << g) %= n;
      }
    }
    lcp[0][i] = ans;
  }
  for (int i = 0; i < n; ++i) {
    mipos[0][i] = sa[i];
    mapos[0][i] = sa[i];
  }
  for (int i = 1; (1 << i) <= n; ++i) {
    for (int j = 0; j + (1 << i) <= n; ++j) {
      lcp[i][j]   = min(lcp[i - 1][j], lcp[i - 1][j + (1 << (i - 1))]);
      mipos[i][j] = min(mipos[i - 1][j], mipos[i - 1][j + (1 << (i - 1))]);
      mapos[i][j] = max(mapos[i - 1][j], mapos[i - 1][j + (1 << (i - 1))]);
    }
  }
  blog[1] = 0;
  for (int i = 2; i <= n; ++i) {
    blog[i] = 1 + blog[i >> 1];
  }
}

int get_lcp(int i, int j) {
  assert(i != j);
  if (i > j) {
    swap(i, j);
  }
  int x = blog[j - i];
  return min(lcp[x][i], lcp[x][j - (1 << x)]);
}

int min_pos(int i, int j) {
  int x = blog[j - i];
  return min(mipos[x][i], mipos[x][j - (1 << x)]);
}

int max_pos(int i, int j) {
  int x = blog[j - i];
  return max(mapos[x][i], mapos[x][j - (1 << x)]);
}

void solve() {
  scanf("%s", s);
  n = strlen(s);
  s[n++] = '!';
  build_sa();
  build_lcp();
  // for (int i = 0; i < n; ++i) {
  //   std::cerr << i << ": " << string(s + sa[i]) << '\n';
  //   if (i < n - 1) {
  //     std::cerr << "  lcp is " << lcp[0][i] << '\n';
  //   }
  // }
  // std::cerr << "----------------" << '\n';
  // for (int i = 0; i < n - 1; ++i) {
  //   string a(s + sa[i]);
  //   string b(s + sa[i + 1]);
  //   assert(a < b);
  //   int x = 0;
  //   while (a[x] == b[x]) {
  //     ++x;
  //   }
  //   if (lcp[0][i] != x) {
  //     std::cerr << "i is " << i << '\n';
  //     std::cerr << a << '\n';
  //     std::cerr << b << '\n';
  //     std::cerr << "x is " << x << '\n';
  //     std::cerr << "lcp is " << lcp[0][i] << '\n';
  //   }
  //   assert(lcp[0][i] == x);
  // }
  long long ans = n - 1;
  for (int i = 0; i < n - 1; ++i) {
    int len = lcp[0][i];
    if (len == 0) {
      continue;
    }
    int l = -1, r = i;
    while (r - l > 1) {
      int j = (l + r) / 2;
      (get_lcp(j, i + 1) >= len ? r : l) = j;
    }
    int from = r;
    l = i + 1, r = n;
    while (r - l > 1) {
      int j = (l + r) / 2;
      (get_lcp(i, j) >= len ? l : r) = j;
    }
    int to = l + 1;
    int maxlen = len + (max_pos(from, to) - min_pos(from, to));
    long long cur_ans = (long long)len * len + maxlen;
    // if (cur_ans == 20) {
    //   std::cerr << "i is " << i << '\n';
    //   std::cerr << "from is " << from << '\n';
    //   std::cerr << "to is " << to << '\n';
    //   std::cerr << "len is " << len << '\n';
    //   std::cerr << "min pos is " << min_pos(from, to) << '\n';
    //   std::cerr << "max pos is " << max_pos(from, to) << '\n';
    // }
    ans = max(ans, cur_ans);
  }
  cout << ans << '\n';
}

int main() {
  int tests = 1;
  //scanf("%d", &tests);
  for (int i = 0; i < tests; ++i) {
    solve();
  }
}
