#include <bits/stdc++.h>
#define sz(x) ((int)(x).size())
using namespace std;
typedef long long ll;

const int L = 128;

vector < int > suffArray(string const& s) {
    int n = sz(s);
    vector < int > c(n), arr(n);
    vector < int > st(L+1);
    for (char c : s) {
        ++st[c + 1];
    }
    for (int i = 1; i < sz(st); ++i)
        st[i] += st[i - 1];
    for (int i = 0; i < n; ++i)
        arr[st[s[i]]++] = i;
    int curc = 0;
    for (int i = 0; i < n; ++i) {
        if (i != 0 && s[arr[i]] != s[arr[i-1]])
            ++curc;
        c[arr[i]] = curc;
    }

    st.assign(n + 1, 0);
    vector < int > arr1(n);
    for (int k = 1; k < n; k <<= 1) {
        fill(st.begin(), st.end(), 0);
        for (int i = 0; i < n; ++i)
            ++st[c[i] + 1];
        for (int i = 1; i < n; ++i)
            st[i] += st[i - 1];
        for (int i : arr) {
            i = (i + n - k) % n;
            arr1[st[c[i]]++] = i;
        }
        arr = arr1;

        vector < int > nc(n);
        int curc = 0;
        for (int i = 0; i < n; ++i) {
            if (i != 0 && (c[arr[i]] != c[arr[i-1]] || c[(arr[i]+k)%n] != c[(arr[i-1]+k)%n]))
                ++curc;
            nc[arr[i]] = curc;
        }
        c = nc;
    }

    return arr;
}

int main() {
    int n;
    string s;
    cin >> s;
    s += '#';
    n = sz(s);
    vector < int > arr = suffArray(s);
    vector<int> s2a(n);
    for (int i = 0; i < n; ++i)
        s2a[arr[i]] = i;
    vector<int> lcp(n);
    int r = 0;
    for (int i = 0; i < n; ++i) {
        int ia = s2a[i];
        if (ia == n - 1) {
            r = 0;
            continue;
        }
        lcp[ia] = r;
        int j = arr[ia+1];
        while (s[i + lcp[ia]] == s[j + lcp[ia]])
            ++lcp[ia];
        r = max(0, lcp[ia] - 1);
    }

    vector<vector<int>> tmin = {arr};
    for (int i = 1; true; ++i) {
        tmin.emplace_back();
        for (int j = 0; j + (1 << i) <= sz(tmin[0]); ++j)
            tmin.back().push_back(min(tmin[i-1][j], tmin[i-1][j+(1<<(i-1))]));
        if (tmin.back().empty()) {
            tmin.pop_back();
            break;
        }
    }
    vector<vector<int>> tmax = {arr};
    for (int i = 1; true; ++i) {
        tmax.emplace_back();
        for (int j = 0; j + (1 << i) <= sz(tmax[0]); ++j)
            tmax.back().push_back(max(tmax[i-1][j], tmax[i-1][j+(1<<(i-1))]));
        if (tmax.back().empty()) {
            tmax.pop_back();
            break;
        }
    }
    vector<int> stL(n+1);
    for (int i = 2; i <= n; ++i) {
        stL[i] = stL[i/2] + 1;
    }
    auto getMin = [&](int l, int r) {
        int len = r - l + 1;
        int d = stL[len];
        return min(tmin[d][l], tmin[d][r+1-(1<<d)]);
    };
    auto getMax = [&](int l, int r) {
        int len = r - l + 1;
        int d = stL[len];
        return max(tmax[d][l], tmax[d][r+1-(1<<d)]);
    };

    vector<int> bl(n-1, 0), br(n-1, 0);
    vector<int> st;
    for (int i = 0; i < n - 1; ++i) {
        while (!st.empty() && lcp[st.back()] >= lcp[i])
            st.pop_back();
        if (st.empty())
            bl[i] = 0;
        else
            bl[i] = st.back() + 1;
        st.push_back(i);
    }
    st.clear();
    for (int i = n - 2; i >= 0; --i) {
        while (!st.empty() && lcp[st.back()] >= lcp[i])
            st.pop_back();
        if (st.empty())
            br[i] = n - 1;
        else
            br[i] = st.back();
        st.push_back(i);
    }

    ll ans = n - 1;
    for (int i = 0; i < n - 1; ++i)
        if (lcp[i] != 0)
            ans = max(ans, 1LL*lcp[i]*lcp[i] + getMax(bl[i], br[i]) - getMin(bl[i], br[i]) + lcp[i]);
    cout << ans << "\n";

    return 0;
}
