#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

struct node {
    int link, len;
    map<int, int> go;
    int first, last;
    node() : link(-1), len(0), go(), first(INF), last(0) {}
    node(node const& n) : link(n.link), len(n.len), go(n.go), first(n.first), last(0) {}
    node(int _len) : link(-1), len(_len), go(), first(_len), last(0) {}
};

vector<node> automata;
vector<bool> used;
vector<vector<int>> graph;

int dfs(int v) {
    automata[v].last = automata[v].first;
    for (int to : graph[v]) {
        if (!used[to]) {
            dfs(to);
            automata[v].last = max(automata[v].last, automata[to].last);
        }
    }
    return 0;
}

const int MAXN = 1e6 + 5;
char buf[MAXN];

ll sqr(ll num) {
    return num * num;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    automata.puba(node());
    scanf("%s", buf);
    int last = 0;
    for (int i = 0; buf[i]; ++i) {
        automata.puba(node(automata[last].len + 1));
        int cur = szof(automata) - 1;
        int c = buf[i] - 'a';
        while (last != -1) {
            if (automata[last].go.count(c)) {
                break;
            }
            automata[last].go[c] = cur;
            last = automata[last].link;
        }
        if (last != -1) {
            int to = automata[last].go[c];
            if (automata[to].len == automata[last].len + 1) {
                automata[cur].link = to;
            } else {
                automata.puba(automata[to]);
                int added = szof(automata) - 1;
                automata[to].link = added;
                automata[added].len = automata[last].len + 1;
                automata[cur].link = added;
                while (last != -1 && automata[last].go[c] == to) {
                    automata[last].go[c] = added;
                    last = automata[last].link;
                }
            }
        } else {
            automata[cur].link = 0;
        }
        last = cur;
    }

    graph.resize(szof(automata));
    used.resize(szof(automata));
    for (int i = 1; i < szof(automata); ++i) {
        graph[automata[i].link].puba(i);
    }

    dfs(0);

    ll ans = 0;

    for (int i = 0; i < szof(automata); ++i) {
        //cerr << automata[i].len << " " << automata[i].first << " " << automata[i].last << endl;
        if (automata[i].first < automata[i].last) {
            ans = max(ans, sqr(automata[i].len) + (automata[i].last - automata[i].first + automata[i].len));
        } else {
            ans = max(ans, (ll) automata[i].len);
        }
    }

    cout << ans << "\n";

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}