#include <stdio.h>
#include <iostream>

using namespace std;

const int MAX = (int)1e6;
int a[MAX];
int ans = 1;

int abs(int x) {
	if (x < 0) {
		return -x;
	}
	return x;
}

bool solution(int n, int cur) {
	bool f = true;
	for (int i = 1; i < n; ++i) {
		// cout << a[i] << " ";
		if (abs(cur - a[i]) > 1) {
			f = false;
			break;
		}
		++cur;
		if (cur > n) {
			cur = 1;
			ans = (i + 1) % n + 1;
		}
	}
	// cout << endl;
	return f;
}

int main() {
    ios::sync_with_stdio(false);
	// freopen("input.txt", "r", stdin);
	int n;
	cin >> n;

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	if (a[0] >= 1 && a[0] <= n) {
		if (solution(n, a[0] + 1)) {
			cout << "YES" << endl;
			cout << ans << endl;
			return 0;
		}
	}

	if (a[0] >= 0 && a[0] <= n - 1) {
		if (solution(n, a[0] + 2)) {
			cout << "YES" << endl;
			cout << ans << endl;
			return 0;
		}
	}

	if (a[0] >= 2 && a[0] <= n + 1) {
		if (solution(n, a[0])) {
			cout << "YES" << endl;
			cout << ans << endl;
			return 0;
		}
	}

	cout << "NO" << endl;

	return 0;
}