#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MX = 2007;

ll x[MX], y[MX];

ll d[MX][MX];

int c[MX];

ll dist(int u, int v) {
    ll dx = x[u] - x[v], dy = y[u] - y[v];
    return dx * dx + dy * dy;
}

int n;
ll mg = 0;
void dfs(int v) {
    c[v] = 1;
    for (int j = 0; j < n; j++) {
        if (d[v][j] >= mg) continue;
        if (c[j] == 0) {
            dfs(j);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            d[i][j] = dist(i, j);
        }
    }
    unsigned long long l = 0, r = 8e18 + 1234567;
    while (r - l > 1) {
        mg = (l + r) >> 1;
        memset(c, 0, sizeof(c));
        int cnt = 0;
        if (mg == 8e18) {
            int x = 228;
        }
        for (int i = 0; i < n; i++) {
            if (c[i] == 0) {
                cnt++;
                if (cnt == 2) break;
                dfs(i);
            }
        }
        if (cnt == 2) {
           l = mg;
        } else {
           r = mg;
        }
    }
    cout << l << endl;
}

