import random
import sys
import math

random.seed(" ".join(sys.argv), 2)

maxv = 200000
tests = []

for prod in range(1, maxv):
  n = 1
  while n * n <= prod:
    if prod % n == 0:
      tests.append((n, prod // n))
      if n != prod // n:
        tests.append((prod // n, n))
    n += 1
  if len(tests) >= maxv:
    break

tests = tests[:maxv]
random.shuffle(tests)

print(len(tests))
for test in tests:
  print(test[0], test[1])
