#include <bits/stdc++.h>
using namespace std;

int const mod = 998244353;

int prod(int a, int b) {
  return (long long) a * b % mod;
}

void add(int &a, int b) {
  if ((a += b) >= mod) {
    a -= mod;
  }
}

int inv(int x) {
  assert(x >= 0);
  assert(x < mod);

  int ans = (mod + 1) / x % mod;
  int value = (mod + 1) % x;
  while (value != 0) {
    value += mod;
    ans += value / x;
    ans %= mod;
    value %= x;
  }

  assert(prod(ans, x) == 1);
  return ans;
}

void solve() {
  int n, k;
  cin >> n >> k;
  vector<int> values = {1};
  while ((int)values.size() <= n) {
    int sum = accumulate(values.begin(), values.end(), 0LL) % mod;
    int avg = prod(sum, inv(values.size()));
    int new_value = prod(avg, k);
    values.push_back(new_value);
  }
  cout << values[n] << '\n';
}

int main() {
  int tests = 1;
  cin >> tests;
  for (int i = 0; i < tests; ++i) {
    solve();
  }
}
