#include <bits/stdc++.h>

const int MAXN = 1e4;
const int MAXR = 4005;

template <typename T>
T sqr(T x) {
    return x * x;
}


std::vector<std::pair<short, bool>> people[MAXN + 1];

int main() {
    int n;
    scanf("%d", &n);
    std::vector<std::vector<int>> peopleV(MAXN + 1);
    for (int i = 0; i < n; i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        peopleV[x].push_back(y);
    }
    int m;
    scanf("%d", &m);
    for (int i = 0; i < m; i++) {
        int x, y, r;
        scanf("%d%d%d", &x, &y, &r);
        for (int sx = std::max(0, x - r); sx <= std::min(MAXN, x + r); sx++) {
            int sqbound = std::max(0, sqr(r) - sqr(sx - x));
            int bound = std::max(0, int(sqrt(sqbound)) - 1);
            while (bound * bound <= sqbound) {
                bound++;
            }
            bound--;
            int miny = y - bound;
            int maxy = bound + y;
            if (miny > maxy) continue;
            people[sx].emplace_back(miny, 0);
            people[sx].emplace_back(maxy, 1);
        }
    }

    int answer = 0;
    for (int i = 0; i <= MAXN; i++) {
        std::sort(peopleV[i].begin(), peopleV[i].end());
        std::sort(people[i].begin(), people[i].end());
        int size = people[i].size();
        int p1 = 0;
        int p2 = 0;
        int balance = 0;
        while (p1 < (int)peopleV[i].size()) {
            if (p2 >= size) {
                answer += (int)peopleV[i].size() - p1;
                break;
            }
            while (p2 < size && (people[i][p2].first < peopleV[i][p1] || (people[i][p2].second == 0 && people[i][p2].first == peopleV[i][p1]))) {
                balance += (people[i][p2++].second ? 1 : -1);
            }
            answer += balance == 0;
            p1++;
        }
    }
    printf("%d\n", answer);
    return 0;
}
