#include "testlib.h"
using namespace std;
const int N = 1e4 + 5;

int f[N];

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int l = inf.readInt();
    int r = inf.readInt();
    for (int i = 0; i < n; ++i) {
        int x = inf.readInt();
        f[i] = x;
    }

    string team_ans = ouf.readLine();
    string jury_ans = ans.readLine();
    if (jury_ans == "Impossible") {
        quitif(team_ans != jury_ans, _wa, "Expected Impossible verdict.");
    } else {
        quitif(team_ans == "Impossible", _wa, "Answer is no Impossible");
        quitif((int)team_ans.size() != n, _pe, "Wrong size of ans, %d != %d", (int)team_ans.size(), n);
        int sum = 0;
        quitif(team_ans[0] != '0' && team_ans[0] != '1', _wa, "AAA");
        for (int i = 0; i < n; ++i) {
            if (team_ans[i] == '1') {
                sum += f[i];
            } else {
                sum -= f[i];
            }
            quitif(sum > r || sum < l, _wa, "Prefix sum %d is out of range and equals to %d.",
             i + 1, sum);
        }
    }

    quitf(_ok, "ok");
    return 0;
}