#include "testlib.h"
using namespace std;
const int N = 1e4 + 5;

int f[N];

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int l = inf.readInt();
    int r = inf.readInt();
    for (int i = 0; i < n; ++i) {
        int x = inf.readInt();
        f[i] = x;
    }

    string team_ans = ouf.readLine();
    string jury_ans = ans.readLine();
    if (team_ans != "Impossible") {
        quitif((int)team_ans.size() != n, _pe, "Wrong size of ans, %d != %d", (int)team_ans.size(), n);
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            if (team_ans[i] == '1') {
                sum += f[i];
            } else if (team_ans[i] == '0') {
                sum -= f[i];
            } else
                quitf(_pe, "Incorrect character");
    
            quitif(sum > r || sum < l, _wa, "Prefix sum %d is out of range and equals to %d.",
             i + 1, sum);
        }
        quitif(jury_ans == "Impossible", _fail, "Jury haven't found answer, but contestant did");
        
    } else {
        
        quitif(jury_ans != "Impossible", _wa, "Contestant haven't found answer, but jury did");
    }

    quitf(_ok, "ok");
    return 0;
}