#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXN = 1e6 + 5;

int link[MAXN];
int go[MAXN][26];
int len[MAXN];
int first[MAXN], last[MAXN];

/*
struct node {
    int link, len;
    map<int, int> go;
    int first, last;
    node() : link(-1), len(0), go(), first(INF), last(0) {}
    node(node const& n) : link(n.link), len(n.len), go(n.go), first(n.first), last(0) {}
    node(int _len) : link(-1), len(_len), go(), first(_len), last(0) {}
};
*/

//vector<node> automata;
int cnt = 0;

vector<bool> used;
vector<vector<int>> graph;

int dfs(int v) {
    last[v] = first[v];
    for (int to : graph[v]) {
        if (!used[to]) {
            dfs(to);
            last[v] = max(last[v], last[to]);
        }
    }
    return 0;
}

char buf[MAXN];

ll sqr(ll num) {
    return num * num;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    memset(go, -1, sizeof go);
    memset(link, -1, sizeof link);

    ++cnt;
    scanf("%s", buf);
    int lastv = 0;
    for (int i = 0; buf[i]; ++i) {
        len[cnt] = len[lastv] + 1;
        first[cnt] = len[cnt];
        int cur = cnt++;
        int c = buf[i] - 'a';
        while (lastv != -1) {
            if (go[lastv][c] != -1) {
                break;
            }
            go[lastv][c] = cur;
            lastv = link[lastv];
        }
        if (lastv != -1) {
            int to = go[lastv][c];
            if (len[to] == len[lastv] + 1) {
                link[cur] = to;
            } else {
                int added = cnt++;
                for (int q = 0; q < 26; ++q) {
                    go[added][q] = go[to][q];
                }
                first[added] = first[to];
                link[added] = link[to];
                
                link[to] = added;
                len[added] = len[lastv] + 1;
                link[cur] = added;
                while (lastv != -1 && go[lastv][c] == to) {
                    go[lastv][c] = added;
                    lastv = link[lastv];
                }
            }
        } else {
            link[cur] = 0;
        }
        lastv = cur;
    }

    graph.resize(cnt);
    used.resize(cnt);
    for (int i = 1; i < cnt; ++i) {
        graph[link[i]].puba(i);
    }

    dfs(0);

    ll ans = 0;

    for (int i = 0; i < cnt; ++i) {
        //cerr << automata[i].len << " " << automata[i].first << " " << automata[i].last << endl;
        if (first[i] < last[i]) {
            ans = max(ans, sqr(len[i]) + (last[i] - first[i] + len[i]));
        } else {
            ans = max(ans, (ll) len[i]);
        }
    }

    cout << ans << "\n";

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}