#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }
const int MAXN = 1e6 + 5;
char buf[MAXN];

int modn(int a, int n) {
    return a >= n ? a - n : a;
}

vector<int> suffarray(string s) {
    int n = szof(s);
    vector<int> classes(n), classes2(n), arr(n), arr2(n), from(max(128, szof(s)) + 1);
    
    for (int i = 0; i < n; ++i) {
        classes[i] = s[i];
        arr[i] = i;
        from[classes[i] + 1]++;
    }
    for (int i = 1; i < szof(from); ++i) {
        from[i] += from[i - 1];
    }

    for (int i = 0; i < n; i = max(i * 2, 1)) {
        for (int j = 0; j < n; ++j) {
            int cur = modn(arr[j] - i + n, n);
            arr2[from[classes[cur]]++] = cur;
        }

        int c = 0;
        from[0] = 0;
        for (int j = 0; j < n; ++j) {
            if (j && (classes[arr2[j]] != classes[arr2[j - 1]] || classes[modn(arr2[j] + i, n)] != classes[modn(arr2[j - 1] + i, n)])) {
                ++c;
                from[c] = j;
            }
            classes2[arr2[j]] = c;
        }

        swap(classes, classes2);
        swap(arr, arr2);
    }

    return arr;
}

int bpv;
vector<pii> rmq;
pii minmax(pii p1, pii p2) {
    return {min(p1.ff, p2.ff), max(p1.ss, p2.ss)};
}

pii s_get(int v, int vl, int vr, int l, int r) {
    if (vr <= l || r <= vl) {
        return {INF, -INF};
    }
    if (l <= vl && vr <= r) {
        return rmq[v];
    }
    int vm = (vl + vr) / 2;
    return minmax(s_get(v * 2, vl, vm, l, r), s_get(v * 2 + 1, vm, vr, l, r));
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    scanf("%s", buf);
    string s = buf;
    int n = szof(s);
    s += '!';
    
    auto arr = suffarray(s);
    vector<int> where(szof(s));

    for (int i = 0; i < szof(s); ++i) {
        where[arr[i]] = i;
    }

    vector<int> lcp(szof(s));

    for (int i = 0; i < szof(s); ++i) {
        if (where[i] == szof(s) - 1) {
            continue;
        }
        auto& val = lcp[where[i]];
        if (i) {
            val = max(lcp[where[i - 1]] - 1, 0);
        }
        while (max(i, arr[where[i] + 1]) + val < szof(s) && s[i + val] == s[arr[where[i] + 1] + val]) {
            ++val;
        }
    }

    /*
    for (int i = 0; i < szof(s); ++i) {
        for (int j = arr[i]; j < szof(s); ++j) {
            cerr << s[j];
        }
        cerr << endl;
        cerr << lcp[i] << endl;
    }
    */

    vector<pii> all;
    for (int i = 0; i < n - 1; ++i) {
        all.puba({lcp[i + 1], i + 1});
    }

    bpv = 1;
    while (bpv < n) {
        bpv *= 2;
    }

    rmq = vector<pii>(bpv * 2, {INF, -INF});

    for (int i = 0; i < n; ++i) {
        rmq[bpv + i] = {arr[i + 1], arr[i + 1]};
    }

    for (int i = bpv - 1; i; --i) {
        rmq[i] = minmax(rmq[i * 2], rmq[i * 2 + 1]);
    }

    ll ans = n;
    sort(bend(all));
    set<int> have;
    have.insert(0);
    have.insert(n);
    for (pii p : all) {
        int pos = p.ss;
        int prev = *--have.lower_bound(pos);
        int next = *have.lower_bound(pos);
        //cerr << p.ff << " " << p.ss << " "  << prev << " " << next << endl;
        pii lr = s_get(1, 0, bpv, prev, next);
        //cerr << (ll) p.ff * p.ff + (lr.ss - lr.ff + p.ff) << endl;
        ans = max(ans, (ll) p.ff * p.ff + (lr.ss - lr.ff + p.ff));
        have.insert(pos);
    }

    cout << ans << "\n";
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}