#include <bits/stdc++.h>
using namespace std;

void solve() {
  int n;
  scanf("%d", &n);
  vector<int> x(n), y(n);
  for (int i = 0; i < n; ++i) {
    scanf("%d%d", &x[i], &y[i]);
  }
  vector<vector<unsigned long long>> w(n, vector<unsigned long long>(n));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      int dx = x[i] - x[j];
      int dy = y[i] - y[j];
      w[i][j] = (long long) dx * dx + (long long) dy * dy;
    }
  }
  vector<unsigned long long> minw(n, ~0ull);
  minw[0] = 0;
  vector<char> used(n);
  unsigned long long ans = 0;
  for (int i = 0; i < n; ++i) {
    int v = -1;
    for (int x = 0; x < n; ++x) {
      if (!used[x] && (v < 0 || minw[x] < minw[v])) {
        v = x;
      }
    }
    assert(v >= 0);
    used[v] = 1;
    ans = max(ans, minw[v]);
    for (int x = 0; x < n; ++x) {
      minw[x] = min(minw[x], w[v][x]);
    }
  }
  cout << ans << '\n';
}

int main() {
  int tests = 1;
  //scanf("%d", &tests);
  for (int i = 0; i < tests; ++i) {
    solve();
  }
}
