#include <map>
#include <queue>
#include <iostream>

using namespace std;

int main(int argc, char *argv[]) {
    string t;
    cin >> t;

    int best = INT_MAX;
    string ans;
    for (int mask = 0; mask < (1 << t.length()); ++mask) {
        vector<int> cnt('z' + 1);
        for (char c : t) {
            cnt[c]++;
        }

        string s = t;
        int changes = 0;
        for (int i = 0; i < s.length(); ++i) {

            if (((mask >> i) & 1) > 0) {
                changes++;

                char rarest = 'a';
                for (char cur = 'a'; cur <= 'z'; ++cur) {
                    if (cnt[cur] < cnt[rarest]) {
                        rarest = cur;
                        if (cnt[rarest] == 0) break;
                    }
                }
                cnt[s[i]]--;
                cnt[rarest]++;
                s[i] = rarest;
            }

        }

        for (int i = 2; i < s.length(); ++i) {
            if (s[i - 2] == s[i] && s[i - 1] == s[i]) {
                changes = -1;
                break;
            }
        }
        for (int i = 0; i < s.length(); ++i) {
            if (cnt[s[i]] > s.length() / 2) {
                changes = -1;
                break;
            }
        }

        if (changes == -1) continue;
        if (changes < best) {
            best = changes;
            ans = s;
        }
    }

    cout << ans;
}