#include <map>
#include <queue>
#include <iostream>

using namespace std;

int main(int argc, char *argv[]) {
    string s;
    cin >> s;

    vector<bool> has_char('z' + 1);
    for (char c : s) {
        has_char[c] = true;
    }

    char missing = 'a';
    for (char c = 'a'; c <= 'z'; ++c) {
        if (!has_char[c]) {
            missing = c;
            break;
        }
    }

    for (int i = 2; i < s.length(); ++i) {
        if (s[i - 2] == s[i] && s[i - 1] == s[i]) {
            s[i] = missing;
        }
    }

    vector<int> cnt('z' + 1);
    for (char c : s) {
        cnt[c]++;
    }

    for (char c = 'a'; c <= 'z'; ++c) {
        if (cnt[c] > s.length() / 2) {

            for (int i = 0, j = cnt[c]; i < s.length() && j > s.length() / 2; ++i) {
                if (s[i] == c) {
                    s[i] = missing;
                    --j;
                }
            }

        }
    }

    cout << s;
}