#include "testlib.h"
using namespace std;

const int MAX_VALUE = (int)1e4;
const int MAX_N = (int)1e5;

template<typename T>
string to_string(const T& x) 
{
    stringstream ss;
    ss << x;
    return ss.str();
}

int main(int argc, char * argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAX_N, "n");
    inf.readEoln();
    for (int i = 0; i < n; i++) 
    {
        inf.readInt(1, MAX_VALUE, "a[" + to_string(i + 1) + "]");
        if (i < n - 1)
            inf.readSpace();
    }    
    inf.readEoln();
    inf.readEof();

    return 0;
}